from enum import Enum

from ..dto import Dto


class LegacyPscApiResponse(Dto):
    def __init__(self, message="", status_code=None, results=None):
        self.message = message
        self.status_code = status_code
        self.results = results


class PscApiErrorCodes(Enum):
    BAD_REQUEST = 400
    NOT_FOUND = 404
    INTERNAL_SERVER_ERROR = 500


class PscApiErrorResponse(Dto):
    encode_settings = {"error_code": lambda x: None if x is None else x.name}
    decode_settings = {
        "error_code": lambda x: None if x is None else PscApiErrorCodes[x]
    }

    def __init__(self, error_code: Enum = None, message: str = ""):
        self.error_code: Enum = error_code
        self.message: str = message
