from ....shared.dto import Dto
from ....shared.file_acquisition.enums.operation import StatusUpdateOperation
from ....shared.file_acquisition.enums.status import StatusUpdateStatus
from ....shared.file_acquisition.enums.source import StatusUpdateSource


class FileAcquisitionMessage(Dto):
    def get_source_id(self, source_name):
        try:
            source_id = int(StatusUpdateSource[source_name.upper()])
            return source_id
        except Exception:
            return None

    def get_operation_id(self, operation_name):
        try:
            operation_id = int(StatusUpdateOperation[operation_name.upper()])
            return operation_id
        except Exception:
            return None

    def get_status_id(self, status_name):
        try:
            status_id = int(StatusUpdateStatus[status_name.upper()])
            return status_id
        except Exception:
            return None
