import os


class GCPAuthClient:

    """
    Sets GOOGLE_APPLICATION_CREDENTIALS to a local file location having
    either client config for external account/web identity
    or service account credentials.
    """

    @staticmethod
    def set_credentials_using_secrets_manager(
        secrets_manager, secret_key, local_file_directly="/tmp"
    ):
        file_name = f"{local_file_directly}/google_application_credentials.json"
        service_account_json = secrets_manager.get_secret(secret_key)
        with open(file_name, "w") as f:
            f.write(service_account_json)
        os.environ["GOOGLE_APPLICATION_CREDENTIALS"] = file_name
