from __future__ import division
from past.utils import old_div
from tic.shared.scoring.score_calulator_base import ScoreCalculatorBase
from tic.shared.utils.utcdatetime import get_utc_now_string

_network_algorithm_version = 1


class NetworkScoreCalculator(ScoreCalculatorBase):
    def calculate(self, reputation_score):
        """
        Default temporary implementation that just calculates without weights
        """
        scores = [part["score"] for part in reputation_score["parts"]]
        if len(scores) > 0:
            reputation_score["value"] = max(scores)
            reputation_score["range"] = max(scores) - min(scores)
            reputation_score["last_update"] = get_utc_now_string()
            reputation_score["version"] = self.version

            # reputation_score['mean'] = scipy.mean(scores)
            reputation_score["mean"] = old_div(sum(scores), len(scores))
            # reputation_score['mode'] = scipy.stats.mode(scores)[0][0]
            reputation_score["mode"] = max(set(scores), key=scores.count)

            # TODO: Find non-scipy alternative for these methods
            # reputation_score['confidence'] = int(round(scipy.clip(len(scores) / float(3) * 10, 0, 10)))
            reputation_score["confidence"] = 0
            # reputation_score['median'] = scipy.median(scores)
            reputation_score["median"] = 0
            # reputation_score['stddev'] = scipy.std(scores)
            reputation_score["stddev"] = 0

    @property
    def version(self):
        return _network_algorithm_version
