from datetime import datetime
from tic.shared.ubs.dtos.analysis.timing import UbsAnalysisTiming
from tic.shared.utils.date_util import utc_now


class BsvTiming(UbsAnalysisTiming):
    def __init__(
        self,
        process_start: datetime = None,
        pulled_file_and_existing_data: datetime = None,
        stored_file: datetime = None,
    ):
        super().__init__()
        self.process_start = process_start if process_start is not None else utc_now()
        self.pulled_file_and_existing_data = pulled_file_and_existing_data
        self.stored_file = stored_file

        super().decode_settings.update(
            {
                "process_start": self.from_iso_8601_if_present,
                "pulled_file_and_existing_data": self.from_iso_8601_if_present,
                "stored_file": self.from_iso_8601_if_present,
            }
        )

        super().encode_settings.update(
            {
                "process_start": self.to_iso_8601_if_present,
                "pulled_file_and_existing_data": self.to_iso_8601_if_present,
                "stored_file": self.to_iso_8601_if_present,
            }
        )
