from datetime import datetime

from ....aws.dynamodb import DynamoDbModel
from ....utils.date_util import from_iso_8601, to_iso_8601, utc_now


class UbsAnalysisResult(DynamoDbModel):
    pkey = {"sha256": "S"}

    encode_settings = {"analysis_date": lambda x: None if x is None else to_iso_8601(x)}

    decode_settings = {
        "analysis_date": lambda x: None if x is None else from_iso_8601(x)
    }

    def __init__(self, sha256: str = None, analysis_date: datetime = None):
        self.sha256 = sha256
        self.analysis_date: datetime = analysis_date or utc_now()
