from ...ubs.util import hash_to_binary


class FilePathInsert(object):
    def __init__(self, sha256, org_key, filepath, num_occurences, first_seen):
        self.sha256 = sha256
        self.org_key = org_key
        self.filepath = filepath
        self.num_occurences = num_occurences
        self.first_seen = first_seen

    def to_tuple(self):
        return (
            hash_to_binary(self.sha256),
            self.org_key,
            self.filepath,
            self.num_occurences,
            self.first_seen,
        )

    def __eq__(self, other):
        if not isinstance(other, FilePathInsert):
            return False
        return (
            self.sha256 == other.sha256
            and self.org_key == other.org_key
            and self.filepath == other.filepath
        )

    def __hash__(self):
        return hash((hash_to_binary(self.sha256), self.org_key, self.filepath))
